
; MapObjekt mit SimpleOOP

Enumeration
  #DiamondIso
  #StaggeredIso
  #StaggeredHex
EndEnumeration

UsePNGImageDecoder()



Class TileObjekt
  
  BeginPrivate
    TileObjektNum.i
    TileObjektSizeX.i
    TileObjektSizeY.i
    TileObjektKoordinateX.i
    TileObjektKoordinateY.i
    List *TileLayerList.i()
  EndPrivate
  
  BeginPublic
    TileObjektVisible.i = #True
  EndPublic
          
  
  Public Method.i SetTileSize(ValueX.i, ValueY.i)
    This\TileObjektSizeX = ValueX
    This\TileObjektSizeY = ValueY
  EndMethod
  
  Public Method.i SetKoordinate(XValue.i, YValue.i)
    This\TileObjektKoordinateX = XValue
    This\TileObjektKoordinateY = YValue
  EndMethod
  
  Private Method.f winkel(x1.f, y1.f, x2.f, y2.f)
    Protected a.f, b.f, c.f, winkel.f
    a.f = x2-x1
    b.f = y2-y1
    c.f = Sqr(a*a+b*b)
    winkel.f = ACos(a/c)*57.29577
    If y1 < y2 : winkel=360-winkel : EndIf
    MethodReturn winkel
  EndMethod
  
  Public Method GetTileKoordinate(*pTile.Point)
    
    *pTile\x = This\TileObjektKoordinateX
    *pTile\y = This\TileObjektKoordinateY
    
    MethodReturn *pTile
    
  EndMethod
  
  
  Public Method SetNum(Num.i)
    This\TileObjektNum = Num
  EndMethod
  
  Public Method GetNum()
    MethodReturn This\TileObjektNum
  EndMethod
  
  
  Public Method AddLayerSprite(IDSprite.i)
    AddElement(This\TileLayerList())
    This\TileLayerList() = IDSprite
  EndMethod
  

Public Method TestMouseOverTile(List Edges.Point(), *pMouse.Point)
  Protected NextPoint.Point, PrevPoint.Point, MinFar.Point, Far.i, FarMin.i, Result.i, IPoint.i, Winkel1.i, Winkel2.i
  Protected WinkelDiff1.i, WinkelTp.i, WinkelDiff2.i
  
  FarMin = -1
  
  For i = 0 To ListSize(Edges())-1
    SelectElement(Edges(),i)
    Far=Sqr(Pow(*pMouse\x-(Edges()\x + This\TileObjektKoordinateX),2)+Pow(*pMouse\y-(Edges()\y + This\TileObjektKoordinateY),2))
    
    If Far < FarMin Or FarMin = -1
      FarMin = Far
      MinFar\x = Edges()\x + This\TileObjektKoordinateX
      MinFar\y = Edges()\y + This\TileObjektKoordinateY
      IPoint = i
    EndIf     
    
  Next
  
  If *pMouse\x = MinFar\x And *pMouse\y = MinFar\y
    ProcedureReturn #True
  EndIf
  
  If IPoint < ListSize(Edges())-1
    SelectElement(Edges(), IPoint+1)
  Else
    SelectElement(Edges(), 0)
  EndIf
  NextPoint\x = Edges()\x + This\TileObjektKoordinateX
  NextPoint\y = Edges()\y + This\TileObjektKoordinateY

  If IPoint > 0
    SelectElement(Edges(), IPoint-1)
  Else
    SelectElement(Edges(), ListSize(Edges())-1)
  EndIf
  PrevPoint\x = Edges()\x + This\TileObjektKoordinateX
  PrevPoint\y = Edges()\y + This\TileObjektKoordinateY
  
Winkel1 = This\winkel(MinFar\x, MinFar\y, NextPoint\x, NextPoint\y)
Winkel2 = This\winkel(MinFar\x, MinFar\y, PrevPoint\x, PrevPoint\y)
  If Winkel2 > Winkel1:Winkel1 + 360:EndIf
  WinkelDiff1 = Winkel1 - Winkel2
  
Winkel1 = This\winkel(MinFar\x, MinFar\y, NextPoint\x, NextPoint\y)
WinkelTp = This\winkel(MinFar\x, MinFar\y, *pMouse\x, *pMouse\y)
  If WinkelTp > Winkel1:Winkel1 + 360:EndIf
  WinkelDiff2 = Winkel1 - WinkelTp
  
  If WinkelDiff1 <= WinkelDiff2
    MethodReturn #True
  EndIf
    
  
  MethodReturn #False
  
EndMethod


  
  Public Method DisplayTile(Transparam.i = 255)
 
    If This\TileObjektVisible = #True
      
      Start3D()
      ForEach This\TileLayerList()
        DisplaySprite3D(This\TileLayerList(),This\TileObjektKoordinateX,This\TileObjektKoordinateY, Transparam)
      Next
      Stop3D()

    EndIf

  EndMethod
  
  
  Public Method DisplayMO()
    
    Start3D()
    ForEach This\TileLayerList()
      DisplaySprite3D(This\TileLayerList(),This\TileObjektKoordinateX,This\TileObjektKoordinateY)
    Next
    
    Stop3D()
    
  EndMethod
  
  
EndClass
  

Class MapObjekt
  
 BeginPrivate
   List *ObjektList.TileObjekt()
   MapTileSizeX.f
   MapTileSizeY.f
   TotalTileCount.i
   List Edges.Point()
 EndPrivate

 BeginPublic
   *TileMouseOver.TileObjekt
   MapObjektSizeX.i
   MapObjektSizeY.i
   MapTileCountX.i
   MaptileCountY.i
   XDifferenz.i
   YDifferenz.i
 EndPublic
 
 
 Public Method BuildMap(KindofMap.i, TileDir.s="", MapStartX.i=0, MapStartY.i=0)
   
   Protected XPos.i, YPos.i, x_.i, y_.i, xsize.i, ysize.i, MOImagePath.s, Num.i
   
   This\TotalTileCount = ((This\MapTileCountX) * (This\MapTileCountY))
   
   This\MapTileSizeX = This\MapObjektSizeX/This\MapTileCountX
   This\MapTileSizeY = This\MapObjektSizeY/This\MapTileCountY
   
   This\TileMouseOver = NewObject.TileObjekt
   
   This\TileMouseOver\SetTileSize(This\MapTileSizeX, This\MapTileSizeY)
   MOImagePath = TileDir + "TeilMO.png"
   This\ImagetoSpritetoTile(MOImagePath, 2)
   This\TileMouseOver\TileObjektVisible = #False
   This\TileMouseOver\SetNum(9999)
   
   
   Select KindofMap
       
     Case #DiamondIso
       ;Diamopnd Map

       ;Koordinaten des Tiles in der Reihenfolge gegen den Uhrzeigersinn
       
       ;Ecke Links Mitte
       AddElement(This\Edges())
       This\Edges()\x = 0
       This\Edges()\y = This\MapTileSizeY /2
       
         ;Ecke Unten       
       AddElement(This\Edges())
       This\Edges()\x = This\MapTileSizeX/2
       This\Edges()\y = This\MapTileSizeY
       
       ;Ecke Rechts Mitte
       AddElement(This\Edges())
       This\Edges()\x = This\MapTileSizeX
       This\Edges()\y = This\MapTileSizeY /2
       
       ;Ecke Oben
       AddElement(This\Edges())
       This\Edges()\x = This\MapTileSizeX /2
       This\Edges()\y = 0
       
      
       
       ; ;Map erstellen Iso Diamond
        For  y_ = 0 To This\MapTileCountY-1
          For x_ = 0 To This\MapTileCountX-1
            AddElement (This\ObjektList())
            This\ObjektList() = NewObject.TileObjekt
            This\ObjektList()\SetTileSize(This\MapTileSizeX, This\MapTileSizeY)
            XPos = MapStartX - (y_ * (This\MapTileSizeX/2))  + (x_ * (This\MapTileSizeX/2))
            YPos = MapStartY + (y_ * (This\MapTileSizeY/2))  + (x_ * (This\MapTileSizeY/2));
            
            This\ObjektList()\SetKoordinate(XPos,YPos)
            This\ObjektList()\SetNum(Num)
            Num+1
            
          Next
        Next
       
     Case #StaggeredIso
       ;Staggered Iso
       
       ;Koordinaten des Tiles in der Reihenfolge gegen den Uhrzeigersinn
       
       ;Ecke Links Mitte
       AddElement(This\Edges())
       This\Edges()\x = 0
       This\Edges()\y = This\MapTileSizeY /2
       
         ;Ecke Unten       
       AddElement(This\Edges())
       This\Edges()\x = This\MapTileSizeX/2
       This\Edges()\y = This\MapTileSizeY
       
       ;Ecke Rechts Mitte
       AddElement(This\Edges())
       This\Edges()\x = This\MapTileSizeX
       This\Edges()\y = This\MapTileSizeY /2
       
       ;Ecke Oben
       AddElement(This\Edges())
       This\Edges()\x = This\MapTileSizeX /2
       This\Edges()\y = 0
       
              
       
       For  y_ = 0 To This\MapTileCountY-1
          For x_ = 0 To This\MapTileCountX-1
            AddElement (This\ObjektList())
            This\ObjektList() = NewObject.TileObjekt
            This\ObjektList()\SetTileSize(This\MapTileSizeX, This\MapTileSizeY) 
            ;Neue Reihe der Tiles kommen nach 1/2 Breite eines Tiles  
            ;MyMap()\Pos\y = y_*#Tile_H_h;
            YPos = y_ * (This\MapTileSizeY/2)
            ;Jede zweite Reihe der Tiles um 1/2 Lnge versetzt
            ; -> wenn y ungerade, dann 1/2 Lnge zu Tilepostion hinzuaddieren 
            If (y_%2=1) 
              ;MyMap()\Pos\x = (x_*#TILE_W) + #Tile_W_h 
              XPos = (x_ * This\MapTileSizeX) + (This\MapTileSizeX/2)
            Else
              ;CallDebugger
              ;MyMap()\Pos\x = (x_*#TILE_W)
              XPos = x_ * This\MapTileSizeX
            EndIf
            
            This\ObjektList()\SetKoordinate(XPos,YPos)
            This\ObjektList()\SetNum(Num)
            Num+1
          Next 
        Next
        
        
      Case #StaggeredHex
        ;Hexagon Map
        
        ;Koordinaten des Tiles in der Reihenfolge gegen den Uhrzeigersinn, Position als Uhrzeit angegeben
        
        ;stehendes Sechseck
       ;Ecke 12 Uhr
       AddElement(This\Edges())
       This\Edges()\x = This\MapTileSizeX * 0.5
       This\Edges()\y = 0
       Test.f = This\Edges()\x
       
         ;Ecke 10 Uhr       
       AddElement(This\Edges())
       This\Edges()\x = 0
       This\Edges()\y = This\MapTileSizeY * 0.25
       Test.f = This\Edges()\y
       
       ;Ecke 8 Uhr
       AddElement(This\Edges())
       This\Edges()\x = 0
       This\Edges()\y = This\MapTileSizeY * 0.75
       
       ;Ecke 6 Uhr
       AddElement(This\Edges())
       This\Edges()\x = This\MapTileSizeX * 0.5
       This\Edges()\y = This\MapTileSizeY
       
       ;Ecke 4 Uhr
       AddElement(This\Edges())
       This\Edges()\x = This\MapTileSizeX
       This\Edges()\y = This\MapTileSizeY * 0.75
       
       ;Ecke 2 Uhr
       AddElement(This\Edges())
       This\Edges()\x = This\MapTileSizeX
       This\Edges()\y = This\MapTileSizeY * 0.25
        
;         ;liegendes Sechseck
;        ;Ecke 11 Uhr
;        AddElement(This\Edges())
;        This\Edges()\x = This\MapTileSizeX/4
;        This\Edges()\y = 0
;        
;          ;Ecke 9 Uhr       
;        AddElement(This\Edges())
;        This\Edges()\x = 0
;        This\Edges()\y = This\MapTileSizeY/2
;        
;        ;Ecke 7 Uhr
;        AddElement(This\Edges())
;        This\Edges()\x = This\MapTileSizeX/4
;        This\Edges()\y = This\MapTileSizeY 
;        
;        ;Ecke 5 Uhr
;        AddElement(This\Edges())
;        This\Edges()\x = This\MapTileSizeX * 0.75
;        This\Edges()\y = This\MapTileSizeY
;        
;        ;Ecke 3 Uhr
;        AddElement(This\Edges())
;        This\Edges()\x = This\MapTileSizeX
;        This\Edges()\y = This\MapTileSizeY/2
;        
;        ;Ecke 1 Uhr
;        AddElement(This\Edges())
;        This\Edges()\x = This\MapTileSizeX * 0.75
;        This\Edges()\y = 0
       
        
        ;Map erstellen Hexagon
        For  y_ = 0 To This\MapTileCountY-1
          For x_ = 0 To This\MapTileCountX-1
            AddElement (This\ObjektList())
            This\ObjektList() = NewObject.TileObjekt
            This\ObjektList()\SetTileSize(This\MapTileSizeX, This\MapTileSizeY) 
             ;Neue Reihe der Tiles kommen nach 0.75 Breite eines Tiles  
             YPos = y_ * (This\MapTileSizeY * 0.75)-1;
             ;Jede zweite Reihe der Tiles um 1/2 Lnge versetzt
             ; -> wenn y ungerade, dann 0.75 Lnge zu Tilepostion hinzuaddieren 
             If (y_%2=1)
               XPos = (x_ * This\MapTileSizeX) + (This\MapTileSizeX * 0.5)-1
             Else
               XPos = (x_ * This\MapTileSizeX)-1
             EndIf
             
            This\ObjektList()\SetKoordinate(XPos,YPos)
            This\ObjektList()\SetNum(Num)
            Num+1
             
           Next
         Next
         
        
    EndSelect
    
   
 EndMethod 
 
 Public Method TestMO(x.i, y.i)
   This\TileMouseOver\DisplayMO()
 EndMethod
 
 
 Public Method UpdateKoordinate()
   ForEach This\ObjektList()
     This\ObjektList()\SetKoordinate(This\XDifferenz, This\YDifferenz)
   Next
 EndMethod
 
 Public Method ImagetoSpritetoTile(ImagePath.s, Order.i=0)
   
   SpriteIDNeu.i = LoadSprite(#PB_Any,ImagePath,#PB_Sprite_AlphaBlending|#PB_Sprite_Texture)
   Sprite3DNeu.i = CreateSprite3D(#PB_Any,SpriteIDNeu)
   ZoomSprite3D(Sprite3DNeu,This\MapTileSizeX,This\MapTileSizeY)
   
   Select Order
       
     Case 0 ;Nur das selektierte Teil
       This\ObjektList()\AddLayerSprite(Sprite3DNeu)
       
     Case 1 ;Alle Teile
       ForEach This\ObjektList()
         This\ObjektList()\AddLayerSprite(Sprite3DNeu)
       Next
       
     Case 2
       This\TileMouseOver\AddLayerSprite(Sprite3DNeu)
       
   EndSelect
   
   
 EndMethod
 
 
 Private Method MouseOverTile()
   Protected pMouse.POINT, pTile.Point
      
   
   pMouse\x = WindowMouseX(0)
   pMouse\y = WindowMouseY(0)

   
   ForEach This\ObjektList()
     
    This\ObjektList()\GetTileKoordinate(@pTile)   
    
    If (((pMouse\y > pTile\y) And (pMouse\y < (pTile\y + This\MapObjektSizeY)))) And ((pMouse\x > pTile\x) And (x < (pTile\x + This\MapObjektSizeX)))
      
      If This\ObjektList()\TestMouseOverTile(This\Edges(), pMouse) = #True
        This\TileMouseOver\SetKoordinate(pTile\x, pTile\y)
        This\TileMouseOver\TileObjektVisible = #True
        MethodReturn #True               
      EndIf
      
    EndIf
      
    
   Next
 
   This\TileMouseOver\TileObjektVisible = #False 
   MethodReturn #False
 EndMethod
  
 
 Public Method SelectTile(Value.i)
   SelectElement(This\ObjektList(), Value)
 EndMethod
 
 
 Private Method DisplayMapObjekt()
   
   ForEach This\ObjektList()
     This\ObjektList()\DisplayTile()
   Next
   
   This\TileMouseOver\DisplayTile(125)
   
 EndMethod
 
 Public Method UpdateMapObjekt()
   Protected pMouse.Point
   Static PrevpMouse.Point
   
   pMouse\x = WindowMouseX(0)
   pMouse\y = WindowMouseY(0)
   
   ExamineKeyboard()
   
   If KeyboardPushed(#PB_Key_A)
     CallDebugger
   EndIf
   
   If pMouse\x <> PrevpMouse\x Or pMouse\y <> PrevpMouse\y
     PrevpMouse\x = pMouse\x
     PrevpMouse\y = pMouse\y 
     
     This\MouseOverTile()
     
   EndIf
   
   This\DisplayMapObjekt()
   
 EndMethod
 
 
EndClass



; TEST

;Init
InitSprite()
InitSprite3D()
InitKeyboard()
InitMouse()


WinX = 0: WinY = 0: WinWidth = 825: WinHeight = 625
ScreenX = 0: ScreenY = 0: ScreenWidth = WinWidth: ScreenHeight = WinHeight

OpenWindow(0, WinX, #PB_Ignore, WinWidth, WinHeight, "test", #PB_Window_ScreenCentered | #PB_Window_SystemMenu)
OpenWindowedScreen(WindowID(0),ScreenX,ScreenY,ScreenWidth,ScreenHeight,#True,0,0)
 

*NewMap.MapObjekt = NewObject.MapObjekt

; ;***STAGGERED ISO***
; *NewMap\MapObjektSizeX = 800
; *NewMap\MapObjektSizeY = 800
; *NewMap\MapTileCountX = 10
; *NewMap\MapTileCountY = 20
; *NewMap\BuildMap(#StaggeredIso, GetCurrentDirectory())
; MyImagePath.s = GetCurrentDirectory() + "Isomap\" + "Tile1.png"
; MyImagePath2.s = GetCurrentDirectory() + "Isomap\" + "Tile2.png";Testlayer2

; ;***DIAMOND ISO***
; *NewMap\MapObjektSizeX = 800
; *NewMap\MapObjektSizeY = 400
; *NewMap\MapTileCountX = 10
; *NewMap\MapTileCountY = 10
; *NewMap\BuildMap(#DiamondIso, GetCurrentDirectory(), 360,40)
; MyImagePath.s = GetCurrentDirectory() + "Isomap\" + "Tile1.png"
; MyImagePath2.s = GetCurrentDirectory() + "Isomap\" + "Tile2.png";Testlayer2

;***STAGGERED HEXAGONAL***
*NewMap\MapObjektSizeX = 800
*NewMap\MapObjektSizeY = 800
*NewMap\MapTileCountX = 10
*NewMap\MapTileCountY = 10 
*NewMap\BuildMap(#StaggeredHex,GetCurrentDirectory() + "Hexagonmap\")
MyImagePath.s = GetCurrentDirectory() + "Hexagonmap\" + "Tile1.png"
MyImagePath2.s = GetCurrentDirectory() + "Hexagonmap\" + "Tile2.png";Testlayer2

*NewMap\ImagetoSpritetoTile(MyImagePath, 1)

*NewMap\SelectTile(25) ; Den Tiles knnen verschiedene Imagelayer zugeordent werden
*NewMap\ImagetoSpritetoTile(MyImagePath2); Testlayer2 zuordnen


 Repeat
    
    Repeat
      
      Event = WindowEvent()
      
      If Event = #PB_Event_CloseWindow
        EXIT = 1
      EndIf
    Until Event = #Null
    
    ClearScreen($000000)
    ExamineKeyboard()
    
    *NewMap\UpdateMapObjekt() ; In dieser Methode werden smtliche Aktualisierungen abgearbeitet

  FlipBuffers()     
  Until EXIT = 1 Or KeyboardPushed(#PB_Key_Escape)
  
  End
; IDE Options = PureBasic 4.60 Beta 3 (Windows - x86)
; CursorPosition = 553
; FirstLine = 529
; Folding = -----
; EnableXP